//
// Copyright (C) 1999-2004 Toshikaz Hirabayashi
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to
// deal in the Software without restriction, including without limitation the
// rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
// sell copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// TOSHIKAZ HIRABAYASHI BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
// OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
// SOFTWARE.
//
// Except as contained in this notice, the name of Toshikaz Hirabayashi shall
// not be used in advertising or otherwise to promote the sale, use or other
// dealings in this Software without prior written authorization from
// Toshikaz Hirabayashi.

#include <WScom.h>
#include <WSDfileSystem.h>
#include <WSClistData.h>

WSDfileSystem::WSDfileSystem(){
}

WSDfileSystem::~WSDfileSystem(){
}

char* WSDfileSystem::adjustFileName(char* str){
WSMFtrace("WSDfileSystem Warring. This system does not support adjustFileName().\n");
  return str;
}

long WSDfileSystem::rename(char*,char*){
WSMFtrace("WSDfileSystem Warring. This system does not support rename().\n");
  return WS_ERR;
}

long WSDfileSystem::deleteFile(char*){
WSMFtrace("WSDfileSystem Warring. This system does not support deleteFile().\n");
  return WS_ERR;
}

long WSDfileSystem::createDir(char*){
WSMFtrace("WSDfileSystem Warring. This system does not support createDir().\n");
  return WS_ERR;
}

long WSDfileSystem::deleteDir(char*){
WSMFtrace("WSDfileSystem Warring. This system does not support deleteDir().\n");
  return WS_ERR;
}

WSClistData* WSDfileSystem::showNetDir(char*,char*){
WSMFtrace("WSDfileSystem Warring. This system does not support showNetDir().\n");
  return NULL;
}
WSClistData* WSDfileSystem::showDir(char*){
WSMFtrace("WSDfileSystem Warring. This system does not support showDir().\n");
  return NULL;
}
WSClistData* WSDfileSystem::showFile(char*){
WSMFtrace("WSDfileSystem Warring. This system does not support showFile().\n");
  return NULL;
}
long WSDfileSystem::check(char*){
WSMFtrace("WSDfileSystem Warring. This system does not support check().\n");
  return 0;
}

static WSDfileSystem* (*_create_handler)() = NULL;
void WSDfileSystem::setCreateInstanceHandler( WSDfileSystem* (*hd)()){
  _create_handler = hd;
}
static WSDfileSystem* theAppFileSystem = NULL;
WSDfileSystem* WSGIappFileSystem(){
  if (theAppFileSystem == NULL){
    if (_create_handler == NULL){
      return NULL;
WSMFtrace("WSGIfileSystem() ERROR. cannot create WSDfileSystem class instance.\n");
    }
    theAppFileSystem = _create_handler();
  }
  return theAppFileSystem;
}


